unit myDateEd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask,Buttons,CalPop;

type
  TMyButton = class(TButton)
  protected
   procedure Click; override;
  public
   constructor Create(AOwner:TComponent); override;
end;

type
  TMyDateEd = class(Tmaskedit)
  private
    FButton:TMyButton;
    FDate: TDateTime;
    FOnDateChange: TNotifyEvent;
  protected
    procedure WMSize( var Message: TWMSize ); message WM_SIZE;
    function GetDate: TDateTime;
    procedure SetDate( dtArg: TDateTime );
    procedure DoExit; override;
  public
    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;
    procedure CreateParams( var Params: TCreateParams ); override;
    property Date: TDateTime read GetDate write SetDate;
  published
    property OnDateChange: TNotifyEvent read FOnDateChange write FOnDateChange;
 end;


var
 frmCalendar: TfrmCalPop;

procedure Register;

implementation

procedure TMyButton.Click;
var
  editParent: TMyDateEd;
begin
  editParent := TMyDateEd( Parent );
  frmCalendar := TfrmCalPop.Create( editParent );
  frmCalendar.ShowModal;
  frmCalendar.Free;
  editparent.SetFocus;
  inherited Click;
end;


constructor TMyButton.Create(AOwner:TComponent);
begin
  inherited Create(Aowner);
  Cursor:=crArrow;
  TabStop:=FALSE;
end;

constructor TMydateEd.Create(AOwner:TComponent);
begin
    inherited Create(AOwner);
    case( upcase(ShortDateFormat[1]) ) of
    'Y': ShortDateFormat:='yyyy'+DateSeparator+'mm'+DateSeparator+'dd';
    'M': ShortDateFormat:='mm'+DateSeparator+'dd'+DateSeparator+'yyyy';
    else ShortDateFormat:='dd'+DateSeparator+'mm'+DateSeparator+'yyyy';
    end;
    AutoSelect:=FALSE;
    Editmask:='!90/90/0000;1;_';
    Width:=120;
    FButton := TMyButton.Create( self );
    FButton.Font.Name:='Marlett';
    FButton.Caption:='6';
    ControlStyle := ControlStyle - [csSetCaption];
    FButton.Visible := TRUE;
    FButton.Parent := self;
    FDate := 0.0;
end;

destructor TMydateEd.Destroy;
begin
  FButton := nil;
  inherited Destroy;
end;


procedure TMydateEd.CreateParams( var Params: TCreateParams );
begin
  inherited CreateParams( Params );
  Params.Style := Params.Style or WS_CLIPCHILDREN;
end;


procedure TMydateEd.WMSize( var Message: TWMSize );
begin
  FButton.Left := Width - Height;
  FButton.Height:=Height-3;
  FButton.Width:=FButton.Height;
  FButton.Refresh;
  if FDate = 0.0 then
     Date := Now;
end;

function TMydateEd.GetDate: TDateTime;
begin
  GetDate := FDate;
end;

procedure TMydateEd.DoExit;
begin
  inherited DoExit;
  try
     Date := StrToDate( Text );
  except
     Date := Now;
     SetFocus;
  end;
end;


procedure TMydateEd.SetDate( dtArg: TDateTime );
var
	FormattedDate : String;
begin
  if FDate <> dtArg then
     begin
        FDate := dtArg;
        Modified := TRUE;
        if FDate = 0 then
           Text := ''
        else
           Text := FormatDateTime( ShortDateFormat, FDate );
        if Assigned( FOnDateChange ) then
           FOnDateChange( self );
     end;
end;



procedure Register;
begin
  RegisterComponents('MyStuff', [TMyDateEd]);
end;

end.
